#include <kgenericfactory.h>
#include <kstandarddirs.h>
#include <qregexp.h>
#include <qcolor.h>
#include <qlabel.h>
#include <ktoolbar.h>
#include <kcombobox.h>
#include <kconfig.h>

#include "ktagebuch.h"
#include "moodplugin.h"
#include "moodpluginui.h"
#include "moodprefs.h"

K_EXPORT_COMPONENT_FACTORY( ktagebuch_mood, KGenericFactory<MoodPlugin> );

MoodPlugin::MoodPlugin( QObject *parent, const char *name,
			      const QStringList &/*args*/ )
	: ktagebuchPlugin( parent, name )
{
	
	connect( ktagebuchapp, SIGNAL(saveEntry()),
		 SLOT(saveEntry()) );
	connect( ktagebuchapp, SIGNAL(loadEntry()),
		 SLOT(loadEntry()) );
	
		
	mPrefs=new MoodPreferences("looknfeel",this);	
}

MoodPlugin::~MoodPlugin()
{
}

void
MoodPlugin::init()
{
	toolbar=new KToolBar((QMainWindow*)ktagebuchapp,QMainWindow::Top);
	new QLabel(i18n("Mood :"),toolbar);
	combobox=new KComboBox(toolbar);
	
	KConfig *config = ktagebuchapp->getConfig();
	config->setGroup("Mood Plugin");
	if (!config->hasKey("moods"))
		mPrefs->save();
	QStringList strList=QStringList(config->readListEntry("moods"));
	for (QStringList::Iterator it=strList.begin();it!=strList.end();++it){
	    combobox->insertItem(i18n(*it));
	}
	combobox->show();	
	loadEntry();
}

bool
MoodPlugin::unload()
{		
	delete combobox;
	delete toolbar;	
	return true;
}

void MoodPlugin::save()
{
}

void MoodPlugin::loadEntry()
{
	QFile file(ktagebuchapp->entryDirPath()+"/mood");
	QString mood;
	if (file.open(IO_ReadOnly)){
		QTextStream ts(&file);
	        mood=ts.read();
		file.close();
		int i=0;
		int count=combobox->count();
		while (mood.compare(combobox->text(i))!=0 && i<count){ i++;}
		if (mood.compare(combobox->text(i))==0){
			combobox->setCurrentItem(i);
		}else{
			combobox->insertItem(mood,0);
		}
	}
}
void MoodPlugin::saveEntry()
{
	QFile file(ktagebuchapp->entryDirPath()+"/mood");
	if (file.open(IO_WriteOnly)){
		QTextStream ts(&file);
		ts<<combobox->currentText();
		file.close();
	}
}
